#include "StdAfx.h"
#include "WorkGroupView.h"
#include "WorkGroupDlg.h"
#include "AddUserDlg.h"
#include "..\..\DuiLib\UIlib.h"
#include "main_frame.hpp"
#include "NeMessengerDlg.h"
#include "AddChatWnd.h"

WorkGroupView::WorkGroupView(WorkGroupController* pController, WorkGroupModel* pModel)
: m_pController(pController)
, m_pModel(pModel)
, m_pWorkGroupDlg(NULL)
, m_pAddUserDlg(NULL)
{
	m_pMainFrame = NULL;
	m_pAddChatWnd = NULL;
}

WorkGroupView::~WorkGroupView(void)
{
	ASSERT(m_pWorkGroupDlg == NULL);	// Ҹڿ   ޸  Ǿ Ѵ.
	ASSERT(m_pAddUserDlg == NULL);
	if (m_pAddChatWnd != NULL)
	{
		::DestroyWindow(m_pAddChatWnd->GetHWND());
		delete m_pAddChatWnd;
		m_pAddChatWnd = NULL;
	}
}
void WorkGroupView::InitView(MainFrame* pFrame)
{
	m_pMainFrame = pFrame;
}

bool WorkGroupView::IsCreated()
{
	bool bReturn = false;

	if (m_pWorkGroupDlg && m_pWorkGroupDlg->GetSafeHwnd())
	{
		bReturn = true;
	}

	return bReturn;
}

void WorkGroupView::Create(ORGVIEWTYPE eViewType)
{
	if (m_pWorkGroupDlg)
	{
		if (m_pWorkGroupDlg->GetSafeHwnd())
			m_pWorkGroupDlg->DestroyWindow();

		delete m_pWorkGroupDlg;
		m_pWorkGroupDlg = NULL;
	}
	
	m_pWorkGroupDlg = new CWorkGroupDlg(m_pController, m_pModel);
	if (NULL != m_pWorkGroupDlg)
	{
		m_pWorkGroupDlg->Create(eViewType, CWorkGroupDlg::IDD, CWnd::GetDesktopWindow());
		m_pWorkGroupDlg->ShowWindow(SW_SHOW);
	}
}

void WorkGroupView::SetORGGroupMemberList(CString strParentID, CString strID)
{
	
}

void WorkGroupView::SetRequestSearch(CString strWord)
{
	
}

bool WorkGroupView::OpenAddUserDlg(CWnd *pParent, int nType)
{
	if (m_pAddChatWnd)
	{
		if (::IsWindow(m_pAddChatWnd->GetHWND()))
		{
			::DestroyWindow(m_pAddChatWnd->GetHWND());
		}
		delete m_pAddChatWnd;
		m_pAddChatWnd = NULL;
	}

	m_pAddChatWnd = new CAddChatWnd(pParent, nType);

	if (!m_pAddChatWnd)
		return false;

	CPoint pt(0, 0);
	RECT rcClient = { 0 };
	GetWindowRect(pParent->GetSafeHwnd(), &rcClient);
	m_pAddChatWnd->Create(pParent->GetSafeHwnd(), _T("AddChatWindow"), WS_POPUP, WS_EX_TOOLWINDOW, NULL);
	m_pAddChatWnd->SetWindowPosition(rcClient);

	return true;
}

bool WorkGroupView::OpenAddUserDlg( WindowImplBase* pParent, int nType )
{
	if (m_pAddChatWnd)
	{
		if (::IsWindow(m_pAddChatWnd->GetHWND()))
		{
			::DestroyWindow(m_pAddChatWnd->GetHWND());
		}
		delete m_pAddChatWnd;
		m_pAddChatWnd = NULL;
	}

	m_pAddChatWnd = new CAddChatWnd(pParent, nType);

	if (!m_pAddChatWnd)
		return false;

	CPoint pt;
	RECT rcClient;
	GetWindowRect(pParent->GetHWND(), &rcClient);
	m_pAddChatWnd->Create(pParent->GetHWND(), _T("AddChatWindow"), WS_POPUP, WS_EX_TOOLWINDOW, NULL);
	m_pAddChatWnd->SetWindowPosition(rcClient);

	return true;
}

void WorkGroupView::Show(ORGVIEWTYPE eViewType)
{
	if (IsCreated())
	{
		m_pWorkGroupDlg->ShowCmd(eViewType);
		m_pWorkGroupDlg->ShowWindow(SW_SHOW);
		m_pWorkGroupDlg->SetForegroundWindow();
	}
}

void WorkGroupView::CreateSearchResult(const CString& strSearchText)
{
	if (m_pWorkGroupDlg)
	{
		if (m_pWorkGroupDlg->GetSafeHwnd())
			m_pWorkGroupDlg->DestroyWindow();

		delete m_pWorkGroupDlg;
		m_pWorkGroupDlg = NULL;
	}

	m_pWorkGroupDlg = new CWorkGroupDlg(m_pController, m_pModel);
	if (NULL != m_pWorkGroupDlg)
	{
		m_pWorkGroupDlg->Create(strSearchText, CWorkGroupDlg::IDD, CWnd::GetDesktopWindow());
		m_pWorkGroupDlg->ShowWindow(SW_SHOW);
	}
}

void WorkGroupView::Close()
{
	if (m_pWorkGroupDlg)
	{
		m_pWorkGroupDlg->DestroyWindow();
		delete m_pWorkGroupDlg;
		m_pWorkGroupDlg = NULL;
	}
}

void WorkGroupView::CloseAddUserDlg()
{
	if (m_pAddChatWnd)
	{
		::DestroyWindow(m_pAddChatWnd->GetHWND());
		delete m_pAddChatWnd;
		m_pAddChatWnd = NULL;
	}
	
}

void WorkGroupView::SetLanguagePack()
{
	if(m_pWorkGroupDlg != NULL)
	{
		m_pWorkGroupDlg->__ResourceLoad();
	}
	if (m_pAddUserDlg !=NULL)
	{
		m_pAddUserDlg->__ResourceLoad();
	}
}

const CString WorkGroupView::GetMemberName( const CString& strUserID ) const
{
	CString strReturn;

	if (m_pWorkGroupDlg)
	{
		strReturn = m_pWorkGroupDlg->GetMemberName(strUserID);
	}

	return strReturn;
}

void WorkGroupView::InitWorkGroup()
{
	if (NULL != m_pWorkGroupDlg) m_pWorkGroupDlg->InitWorkGroupTree();
}

void WorkGroupView::InitOrgGroup(MemberGroupListAction orgAction)
{
	if (orgAction == ADD_MAINORGGROUP)
	{
		if (NULL != GET_MESSENGER_DLG()->GetMainFrame()) 
		{
			GET_MESSENGER_DLG()->GetMainFrame()->UpdateOrganizationList(m_pModel->GetOrgGroupVector());
		}
	}
	else if (orgAction == ADD_WORKORGGROUP)
	{
		if (NULL != m_pWorkGroupDlg) 
		{
			m_pWorkGroupDlg->InitOrgGroupTree();
		}
	}
	
}

void WorkGroupView::InitMemberList(bool bSearchList, MemberSearchAction action)
{
	//if (NULL != m_pWorkGroupDlg) m_pWorkGroupDlg->InitMemberList(bSearchList);
	if (NULL != GET_MESSENGER_DLG()->GetMainFrame()) 
	{
		if (bSearchList)
		{
			if (action == DETAIL_ORG_SEARCH)
			{
				if (NULL != m_pWorkGroupDlg) 
				{
					m_pWorkGroupDlg->InitMemberList(bSearchList);
				}
			}
			else
			{
				GET_MESSENGER_DLG()->GetMainFrame()->UpdateSearchWndMember(m_pModel->GetMemberVector(), action);
			}
			

		}
		else
		{
			if (action == DETAIL_ORG_SEARCH)
			{
				if (NULL != m_pWorkGroupDlg) 
				{
					m_pWorkGroupDlg->InitMemberList(bSearchList);
				}
			}
			else
			{
				GET_MESSENGER_DLG()->GetMainFrame()->UpdateOrganizationMember(m_pModel->GetMemberVector());
			}
		}
	}
	
}

void WorkGroupView::InitAddUserList()
{
	//if (NULL != m_pAddUserDlg) m_pAddUserDlg->InitMemberList();
	if (m_pAddChatWnd != NULL)
	{
		m_pAddChatWnd->InitMemberList(m_pModel->GetSelectedUserVector());
	}
}

void WorkGroupView::UpdateMemberStatus( LPCWSTR strUserId )
{
	if (GET_MESSENGER_DLG()->GetMainFrame() != NULL)
	{
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateMemberStatus(strUserId);
	}
	if (IsCreated())
	{
		m_pWorkGroupDlg->UpdateMemberStatus(strUserId);
	}

	if (NULL != m_pAddChatWnd && m_pAddChatWnd->GetHWND())
	{
		m_pAddChatWnd->UpdateMemberStatus(strUserId);
	}
}

void WorkGroupView::UpdateMemberIPTStatus( LPCWSTR strUserId )
{
	if (GET_MESSENGER_DLG()->GetMainFrame() != NULL)
	{
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateMemberIPTStatus(strUserId);
	}
	if (IsCreated())
	{
		m_pWorkGroupDlg->UpdateMemberIPTStatus(strUserId);
	}
	if (NULL != m_pAddUserDlg && m_pAddUserDlg->GetSafeHwnd())
	{
//		m_pAddUserDlg->UpdateMemberIPTStatus(strUserId);
	}
}

void WorkGroupView::SetReadOnly( BOOL bStatus )
{
	if (m_pWorkGroupDlg)
		m_pWorkGroupDlg->SetReadOnly(bStatus);
}

void WorkGroupView::ChangeMyStatus(GTUserStatusType eMyStatus)
{
	if (IsCreated())
	{
		m_pWorkGroupDlg->ChangeMyStatus(eMyStatus);
	}

	if (NULL != m_pAddChatWnd && m_pAddChatWnd->GetHWND())
	{
		m_pAddChatWnd->ChangeMyStatus(eMyStatus);
	}
	if (GET_MESSENGER_DLG()->GetMainFrame() != NULL)
	{
		GET_MESSENGER_DLG()->GetMainFrame()->ChangeMyStatus(eMyStatus);
	}
}

void WorkGroupView::RefreshButtonStatus()
{
	if (IsCreated())
	{
		m_pWorkGroupDlg->RefreshButtonStatus();
	}
}


